VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsImagePrev"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' ---------------------------------------------------
' Autor:            Leandro I. Ascierto
' Date:             9 de Marzo de 2013
' Web:              www.leandroascierto.com
' Requirements:     Windows XP or Later
' ---------------------------------------------------

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hdc As Long, ByRef pBitmapInfo As BITMAPINFO, ByVal un As Long, ByRef lplpVoid As Long, ByVal Handle As Long, ByVal dw As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal Hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal Hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long
Private Declare Sub CreateStreamOnHGlobal Lib "ole32.dll" (ByRef hGlobal As Any, ByVal fDeleteOnRelease As Long, ByRef ppstm As Any)
Private Declare Function ImageList_Add Lib "comctl32" (ByVal hImageList As Long, ByVal hBitmap As Long, ByVal hBitmapMask As Long) As Long
Private Declare Function ImageList_GetIconSize Lib "comctl32.dll" (ByVal himl As Long, ByRef cx As Long, ByRef cy As Long) As Long
Private Declare Function ImageList_SetImageCount Lib "comctl32.dll" (ByVal himl As Long, ByVal uNewCount As Long) As Long

' ------------------------------------------------------- GDI Plus -------------------------------------------------------------------
Private Declare Function GdipDrawImageRectRectI Lib "gdiplus" (ByVal hGraphics As Long, ByVal hImage As Long, ByVal dstX As Long, ByVal dstY As Long, ByVal dstWidth As Long, ByVal dstHeight As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal SrcWidth As Long, ByVal SrcHeight As Long, ByVal srcUnit As Long, Optional ByVal imageAttributes As Long = 0, Optional ByVal Callback As Long = 0, Optional ByVal CallbackData As Long = 0) As Long
Private Declare Function GdipCreateFromHDC Lib "gdiplus" (ByVal hdc As Long, ByRef graphics As Long) As Long
Private Declare Function GdipDeleteGraphics Lib "gdiplus" (ByVal graphics As Long) As Long
Private Declare Function GdiplusStartup Lib "gdiplus" (ByRef Token As Long, ByRef lpInput As GDIPlusStartupInput, Optional ByRef lpOutput As Any) As Long
Private Declare Function GdiplusShutdown Lib "gdiplus" (ByVal Token As Long) As Long
Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal Image As Long) As Long
Private Declare Function GdipGetImageDimension Lib "gdiplus" (ByVal Image As Long, ByRef Width As Single, ByRef Height As Single) As Long
Private Declare Function GdipLoadImageFromStream Lib "gdiplus" (ByVal Stream As Any, ByRef Image As Long) As Long
Private Declare Function GdipTranslateWorldTransform Lib "gdiplus" (ByVal graphics As Long, ByVal dx As Single, ByVal dy As Single, ByVal Order As Long) As Long
Private Declare Function GdipRotateWorldTransform Lib "gdiplus" (ByVal graphics As Long, ByVal Angle As Single, ByVal Order As Long) As Long

Private Type ARGB
    Blue            As Byte
    Green           As Byte
    Red             As Byte
    Alpha           As Byte
End Type


Private Type BITMAPINFOHEADER
    biSize              As Long
    biWidth             As Long
    biHeight            As Long
    biPlanes            As Integer
    biBitCount          As Integer
    biCompression       As Long
    biSizeImage         As Long
    biXPelsPerMeter     As Long
    biYPelsPerMeter     As Long
    biClrUsed           As Long
    biClrImportant      As Long
End Type

Private Type BITMAPINFO
    bmiHeader   As BITMAPINFOHEADER
    bmiColors   As ARGB
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion              As Long
    DebugEventCallback          As Long
    SuppressBackgroundThread    As Long
    SuppressExternalCodecs      As Long
End Type


Private Const GdiPlusVersion        As Long = 1&
Private Const IconVersion           As Long = &H30000
    
Private Const BI_RGB                As Long = 0&
Private Const DIB_RGB_COLORS        As Long = 0&

Private GdipToken           As Long
Private m_lWidth            As Long
Private m_lHeight           As Long
Private mImgShadow          As Long
Private m_hImageList        As Long
Private m_ArrImgProgress()  As Byte
Private ArrShadow()         As Byte

 
Private Sub CreateShadowImage()
    'Dim ArrShadow() As Byte
    'Dim i As Long
    'Dim j As Long
    
    'Const sHexShadow = "89504E470D0A1A0A0000000D4948445200000010000000100804000000B5FA37EA000000A54944415478DAA5D1D16A02311085E12F71774" & _
                       "58B8214EF7DFF772BBD902E1863E2C5AEAE6929143A1098C9FCCC999CF0DF08DFF2475DE7F30204511405544551D4050856D63ABD4E7573" & _
                       "955CDDA62953FBAD913E79B7B112E27C110D0D70B43388C4A744D700075B9DB00051DF007B1BFDEB048F75E6C8D31B16A0C80D30BAC88AA" & _
                       "772959C1C1DEC65A34FA3AC2E40919C31FA50245FCE92D21AD51B7E1AF567AB7FFDAC3BD7D73984A6C5F29A0000000049454E44AE426082"
                       
    'ReDim ArrShadow((Len(sHexShadow) / 2) - 1)
    
    'For i = 0 To Len(sHexShadow) - 1 Step 2
    '    ArrShadow(j) = CLng("&H" & Mid$(sHexShadow, i + 1, 2))
    '    j = j + 1
    'Next
    
    ArrShadow = LoadResData("SHADOW", "CUSTOM")
    
    LoadImageFromStream ArrShadow, mImgShadow
               
End Sub



Private Function AddProgress() As Long
    Dim hGraphics   As Long
    Dim ImgWidth    As Single
    Dim ImgHeight   As Single
    Dim hImage      As Long
    Dim OldhDib     As Long
    '-----
    Dim PLeft As Long, PTop As Long
    Dim ReqWidth As Long, ReqHeight As Long
    Dim HScale As Double, VScale As Double
    Dim MyScale As Double
  
    Dim tBITMAPINFO     As BITMAPINFO
    Dim Index           As Long
    Dim TempDC          As Long
    Dim hdc             As Long
    Dim hDIB            As Long
    Dim ProgW           As Single
    Dim ProgH           As Single
    Dim i As Long
    
    
    m_ArrImgProgress = LoadResData("Loading", "CUSTOM")
    
    LoadImageFromStream m_ArrImgProgress, hImage
    
    If hImage Then
    
        GdipGetImageDimension hImage, ProgW, ProgH
        
        With tBITMAPINFO.bmiHeader
            .biSize = Len(tBITMAPINFO.bmiHeader)
            .biBitCount = 32
            .biHeight = m_lWidth
            .biWidth = m_lHeight
            .biPlanes = 1
            .biSizeImage = .biWidth * .biHeight * 4&
        End With
    
        For i = 1 To 12

            TempDC = GetDC(0&)
        
            hdc = CreateCompatibleDC(TempDC)
    
            hDIB = CreateDIBSection(TempDC, tBITMAPINFO, DIB_RGB_COLORS, 0&, 0&, 0&)
        
            Call ReleaseDC(0&, TempDC)
    
            OldhDib = SelectObject(hdc, hDIB)
            
            GdipCreateFromHDC hdc, hGraphics
            
            PLeft = (m_lWidth / 2) - 16
            PTop = (m_lHeight / 2) - 16
            
            
            If GdipRotateWorldTransform(hGraphics, (i * 30) + 180, 0) = 0 Then
                Call GdipTranslateWorldTransform(hGraphics, (m_lWidth / 2), (m_lHeight / 2), 1)
            End If
    
            GdipDrawImageRectRectI hGraphics, hImage, (ProgW / 2), (ProgH / 2), -ProgW, -ProgH, 0, 0, ProgW, ProgH, &H2, 0&, 0&, 0&
    
            GdipDeleteGraphics hGraphics
            
            Call SelectObject(hdc, OldhDib)
            
            Call ImageList_Add(m_hImageList, hDIB, 0)
            
            
            Call DeleteObject(hDIB)
            Call DeleteDC(hdc)
        Next
        
        
        
        GdipDisposeImage hImage
            
    End If
    
End Function



Public Function AddImagen(ByRef bvData() As Byte) As Long
    Dim hGraphics   As Long
    Dim ImgWidth    As Single
    Dim ImgHeight   As Single
    Dim hImage      As Long
    Dim OldhDib     As Long
    '-----
    Dim PLeft As Long, PTop As Long
    Dim ReqWidth As Long, ReqHeight As Long
    Dim HScale As Double, VScale As Double
    Dim MyScale As Double
  
    Dim tBITMAPINFO     As BITMAPINFO
    Dim Index           As Long
    Dim TempDC          As Long
    Dim hdc             As Long
    Dim hDIB            As Long

    
    Call LoadImageFromStream(bvData, hImage)
    
    If hImage <> 0 Then

        With tBITMAPINFO.bmiHeader
            .biSize = Len(tBITMAPINFO.bmiHeader)
            .biBitCount = 32
            .biHeight = m_lWidth
            .biWidth = m_lHeight
            .biPlanes = 1
            .biSizeImage = .biWidth * .biHeight * 4&
        End With

        TempDC = GetDC(0&)
    
        hdc = CreateCompatibleDC(TempDC)

        hDIB = CreateDIBSection(TempDC, tBITMAPINFO, DIB_RGB_COLORS, 0&, 0&, 0&)
    
        Call ReleaseDC(0&, TempDC)

        OldhDib = SelectObject(hdc, hDIB)
        
        GdipCreateFromHDC hdc, hGraphics
        
        GdipGetImageDimension hImage, ImgWidth, ImgHeight
        
        If (ImgWidth > m_lWidth) Or (ImgHeight > m_lHeight) Then
            
            HScale = m_lWidth / ImgWidth
            VScale = m_lHeight / ImgHeight
            
            MyScale = IIf(VScale >= HScale, HScale, VScale)
              
            ReqWidth = (ImgWidth * MyScale) - 10
            ReqHeight = (ImgHeight * MyScale) - 10
              
            PLeft = ((m_lWidth - ReqWidth) / 2)
            'PTop = ((m_lHeight - ReqHeight) / 2)
            
            PTop = ((m_lHeight - ReqHeight)) - 5
        Else
            ReqWidth = ImgWidth
            ReqHeight = ImgHeight
            PLeft = ((m_lWidth - ReqWidth) / 2)
            PTop = ((m_lHeight - ReqHeight) / 2)
        End If
            

        GdipDrawImageRectRectI hGraphics, hImage, PLeft, PTop, ReqWidth, ReqHeight, 0, 0, ImgWidth, ImgHeight, &H2, 0&, 0&, 0&
            
        GdipDisposeImage hImage

        RenderStretchPlus hGraphics, PLeft - 5, PTop - 5, ReqWidth + 10, ReqHeight + 10, mImgShadow, 0, 0, 16, 16, 7
        
        GdipDeleteGraphics hGraphics
        
        Call SelectObject(hdc, OldhDib)
        
        AddImagen = ImageList_Add(m_hImageList, hDIB, 0)
        
        Call DeleteObject(hDIB)
        Call DeleteDC(hdc)
        
    End If
End Function
 
Private Function LoadImageFromStream(ByRef bvData() As Byte, ByRef hImage As Long) As Boolean

    On Local Error GoTo LoadImageFromStream_Error
    
    Dim IStream     As IUnknown
    
    Call CreateStreamOnHGlobal(bvData(0), 0&, IStream)
   
    If Not IStream Is Nothing Then
        
        If GdipLoadImageFromStream(IStream, hImage) = 0 Then
            
            LoadImageFromStream = True

        End If
            
    End If

    Set IStream = Nothing
    
LoadImageFromStream_Error:

End Function


Public Function Init(ByVal hImageList As Long) As Boolean
    If GdipToken Then
        m_hImageList = hImageList
        ImageList_SetImageCount hImageList, 0
        Call ImageList_GetIconSize(hImageList, m_lWidth, m_lHeight)
        Call AddProgress
    End If
End Function

Private Sub Class_Initialize()
    InitGDI
    CreateShadowImage
End Sub


Private Sub Class_Terminate()
    If mImgShadow <> 0 Then GdipDisposeImage mImgShadow
    TerminateGDI
End Sub

Private Sub InitGDI()
    Dim GdipStartupInput As GDIPlusStartupInput
    GdipStartupInput.GdiPlusVersion = GdiPlusVersion
    Call GdiplusStartup(GdipToken, GdipStartupInput, ByVal 0&)
End Sub
 
Private Sub TerminateGDI()
    If GdipToken <> 0 Then Call GdiplusShutdown(GdipToken)
End Sub

Private Function IsArrayDim(ByVal lpArray As Long) As Boolean
    Dim lAddress As Long
    Call CopyMemory(lAddress, ByVal lpArray, &H4)
    IsArrayDim = Not (lAddress = 0)
End Function
