Attribute VB_Name = "MdlAutocompleteSuggestion"
Option Explicit

'----------------------------------------------------------------
'Autor:         Leandro Ascierto
'Mail:          leandroascierto @hotmail.com
'Date:          22/03/2009
'Description:   Autocomplete suggestion google in EditBox
'Use:           SubClassEdit Text1.hwnd
'----------------------------------------------------------------

'=========User32 Api========
Private Declare Function EndPaint Lib "USER32" (ByVal Hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function BeginPaint Lib "USER32" (ByVal Hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal Hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32.dll" (ByVal hdc As Long, ByRef lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function RedrawWindow Lib "USER32" (ByVal Hwnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Private Declare Function SetTimer Lib "USER32" (ByVal Hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "USER32" (ByVal Hwnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Function WindowFromPoint Lib "user32.dll" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Integer
Private Declare Function IsWindow Lib "user32.dll" (ByVal Hwnd As Long) As Long
Private Declare Function IsWindowVisible Lib "user32.dll" (ByVal Hwnd As Long) As Long
Private Declare Function GetWindowText Lib "USER32" Alias "GetWindowTextA" (ByVal Hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function SetWindowText Lib "USER32" Alias "SetWindowTextA" (ByVal Hwnd As Long, ByVal lpString As String) As Long
Private Declare Function ShowWindow Lib "user32.dll" (ByVal Hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function GetSysColor Lib "USER32" (ByVal nIndex As Long) As Long
Private Declare Function ScreenToClient Lib "user32.dll" (ByVal Hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetCursorPos Lib "USER32" (lpPoint As POINTAPI) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal Hwnd As Long) As Long
Private Declare Function SetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DrawText Lib "USER32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function DestroyWindow Lib "USER32" (ByVal Hwnd As Long) As Long
Private Declare Sub SetWindowPos Lib "USER32" (ByVal Hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function SendMessage Lib "USER32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, ByVal lParam As Any) As Long
Private Declare Function CreateWindowEx Lib "USER32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function SetWindowLong Lib "USER32" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "USER32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal Hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal Hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function OffsetRect Lib "USER32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function PtInRect Lib "USER32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetFocus Lib "user32.dll" () As Long
Private Declare Sub keybd_event Lib "user32.dll" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)


'=========GDI32 Api========
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function GetTextColor Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function SetBkColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long


'=========Wininet Api========
Private Declare Function InternetOpen Lib "wininet" Alias "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, ByVal sProxyBypass As String, ByVal lFlags As Long) As Long
Private Declare Function InternetCloseHandle Lib "wininet" (ByVal hInet As Long) As Integer
Private Declare Function InternetReadFile Lib "wininet" (ByVal hFile As Long, ByVal sBuffer As String, ByVal lNumBytesToRead As Long, lNumberOfBytesRead As Long) As Integer
Private Declare Function InternetOpenUrl Lib "wininet" Alias "InternetOpenUrlA" (ByVal hInternetSession As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long

'=========Oleaut32 Api========
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByVal lColorRef As Long) As Long

'=========Kernel32 Api========
Private Declare Function WideCharToMultiByte Lib "KERNEL32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByRef lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpDefaultChar As String, ByVal lpUsedDefaultChar As Long) As Long
Private Declare Function MultiByteToWideChar Lib "KERNEL32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByRef lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Function GetLocaleInfo Lib "KERNEL32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long
Private Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

'=========Constantes========
Private Const HWND_TOPMOST              As Long = -1
Private Const HWND_NOTOPMOST            As Long = -2
Private Const SWP_NOSIZE                As Long = &H1
Private Const SWP_NOMOVE                As Long = &H2
Private Const SWP_NOACTIVATE            As Long = &H10
Private Const SWP_SHOWWINDOW            As Long = &H40

Private Const WS_BORDER                 As Long = &H800000
Private Const WS_CLIPSIBLINGS           As Long = &H4000000
Private Const WS_POPUP                  As Long = &H80000000
Private Const WS_DISABLED               As Long = &H8000000
Private Const WS_CHILD                  As Long = &H40000000

Private Const WS_EX_NOPARENTNOTIFY      As Long = &H4&
Private Const WS_EX_TOOLWINDOW          As Long = &H80&
Private Const WS_EX_TOPMOST             As Long = &H8&
Private Const WS_EX_WINDOWEDGE          As Long = &H100&

Private Const WM_LBUTTONDOWN            As Long = &H201
Private Const WM_PAINT                  As Long = &HF&
Private Const WM_SETCURSOR              As Long = &H20
Private Const WM_KILLFOCUS              As Long = &H8
Private Const WM_DESTROY                As Long = &H2
Private Const WM_GETFONT                As Long = &H31
Private Const WM_KEYDOWN                As Long = &H100
Private Const WM_LBUTTONUP              As Long = &H202
Private Const WM_SETFOCUS               As Long = &H7
Private Const WM_KEYUP                  As Long = &H101

Private Const COLOR_HIGHLIGHTTEXT       As Long = 14
Private Const COLOR_MENUTEXT            As Long = 7
Private Const COLOR_HIGHLIGHT           As Long = 13

Private Const EM_GETSEL                 As Long = &HB0
Private Const EM_SETSEL                 As Long = &HB1

Private Const DT_CALCRECT               As Long = &H400

Private Const INTERNET_OPEN_TYPE_DIRECT As Long = 1
Private Const INTERNET_OPEN_TYPE_PROXY  As Long = 3
Private Const INTERNET_FLAG_RELOAD      As Long = &H80000000

Private Const GWL_WNDPROC               As Long = (-4)
Private Const GWL_STYLE                 As Long = -16

Private Const CP_UTF8                   As Long = 65001

Private Const LOCALE_SISO639LANGNAME As Long = &H59
Private Const LOCALE_USER_DEFAULT As Long = &H400



'=========Estructuras========
Private Type UcsRgbQuad
    R                       As Byte
    G                       As Byte
    B                       As Byte
    a                       As Byte
End Type

Private Type RECT
    Left                    As Long
    Top                     As Long
    Right                   As Long
    Bottom                  As Long
End Type

Private Type POINTAPI
    x                       As Long
    y                       As Long
End Type

Private Type PAINTSTRUCT
    hdc                     As Long
    fErase                  As Long
    rcPaint                 As RECT
    fRestore                As Long
    fIncUpdate              As Long
    rgbReserved(1 To 32)    As Byte
End Type

Private Type tItems
    Caption                 As String
    NumberReslut            As String
    Rec                     As RECT
End Type



Private Handle              As Long
Private ControlPrevProc     As Long
Private PrevProc            As Long
Private Item()              As tItems
Private mDC                 As Long
Private mCurrIndex          As Long
Private hEdit               As Long
Private mText               As String


Public mSearcherOfSuggestions           As String
Public mLangName                        As String 'Maybe not so,you can modify



Public Sub SubClassEdit(Hwnd As Long)

    Dim WinStyle As Long
    Dim WinStyleEx As Long

    mLangName = GetSystemLocaleInfo(LOCALE_SISO639LANGNAME) 'Maybe not so, you can modify

    hEdit = Hwnd

    WinStyle = WS_POPUP Or WS_BORDER Or WS_CLIPSIBLINGS Or WS_CHILD Or WS_DISABLED
    WinStyleEx = WS_EX_TOOLWINDOW Or WS_EX_TOPMOST Or WS_EX_WINDOWEDGE

    Handle = CreateWindowEx(WinStyleEx, "#32768", "Google Suggestion", WinStyle, 0, 0, 0, 0, Hwnd, ByVal 0&, App.hInstance, ByVal 0&)
 
    ControlPrevProc = SetWindowLong(hEdit, GWL_WNDPROC, AddressOf ControlProc)
    
    PrevProc = SetWindowLong(Handle, GWL_WNDPROC, AddressOf WindowProc)
End Sub


Public Sub StopSubClass()
    SetWindowLong Handle, GWL_WNDPROC, PrevProc
    SetWindowLong hEdit, GWL_WNDPROC, ControlPrevProc
    KillTimer Handle, 0
    DestroyWindow Handle
End Sub


Sub TimerProc(ByVal Hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long)
   Dim PT As POINTAPI
   Dim WfP As Long

    If GetKeyState(1) < 0 Then
        GetCursorPos PT
        WfP = WindowFromPoint(PT.x, PT.y)
        If WfP <> Hwnd And WfP <> hEdit Then
            ShowWindow Handle, 0
        End If
    End If
End Sub


Public Function WindowProc(ByVal Hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim CapRec As RECT
    Dim PT As POINTAPI
    Dim PS As PAINTSTRUCT
    Dim hBrush As Long
    Dim hPen As Long
    Dim i As Integer
    

    If uMsg = WM_SETCURSOR Then

        GetCursorPos PT
        ScreenToClient Hwnd, PT
        
        For i = 0 To UBound(Item)
            If PtInRect(Item(i).Rec, PT.x, PT.y) And mCurrIndex <> i Then
                mCurrIndex = i
                RedrawWindow Hwnd, ByVal 0&, ByVal 0&, &H1
                Exit For
            End If
        Next
        
        Select Case HiWord(lParam)
        
            Case WM_LBUTTONUP
                If mCurrIndex > -1 Then
                    Call SetEditText(hEdit, Item(mCurrIndex).Caption)
                    keybd_event vbKeyReturn, 0, 0, 0
                    keybd_event vbKeyReturn, 0, &H2, 0
                End If
                ShowWindow Handle, 0
                
            Case WM_LBUTTONDOWN
                'Cancel beep
                Exit Function
                
        End Select

    End If


    If uMsg = WM_PAINT Then

        
        BeginPaint Hwnd, PS

        mDC = PS.hdc

        DeleteObject SelectObject(mDC, SendMessage(hEdit, WM_GETFONT, 0, ByVal 0&))
        
        hBrush = CreateSolidBrush(GetPixel(GetDC(hEdit), 0, 0))
        FillRect mDC, PS.rcPaint, hBrush
        DeleteObject hBrush
        
        SetBkMode mDC, 0

        SetTextColor mDC, GetSysColor(COLOR_MENUTEXT)
        
        For i = 0 To UBound(Item)
            With Item(i)
                SetRect CapRec, 5, .Rec.Top, .Rec.Right - 5, .Rec.Bottom
                If i = mCurrIndex Then
                    hPen = CreatePen(0, 1, GetSysColor(COLOR_HIGHLIGHT))
                    hBrush = CreateSolidBrush(pvAlphaBlend(vbHighlight, vbWindowBackground, 120))
                    SelectObject mDC, hBrush
                    SelectObject mDC, hPen
                    SetTextColor mDC, GetSysColor(COLOR_HIGHLIGHTTEXT)
                    Rectangle mDC, 0, .Rec.Top, .Rec.Right - .Rec.Left, .Rec.Top + (.Rec.Bottom - .Rec.Top)
                    DrawText mDC, .Caption, Len(.Caption), CapRec, 0
                    SetTextColor mDC, GetSysColor(COLOR_MENUTEXT)
                    DeleteObject hPen
                    DeleteObject hBrush
                Else
                    DrawText mDC, .Caption, Len(.Caption), CapRec, 0
                End If
            End With
         Next

         EndPaint Hwnd, PS
    End If
  
    WindowProc = CallWindowProc(PrevProc, Hwnd, uMsg, wParam, lParam)

End Function


Public Function ControlProc(ByVal Hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    On Error GoTo ErrHandler
    If uMsg = WM_KEYDOWN And IsWindowVisible(Handle) Then
        Select Case wParam
            Case vbKeyDown
            
                mCurrIndex = mCurrIndex + 1
                
                If mCurrIndex > UBound(Item) Then mCurrIndex = -1
                
                RedrawWindow Handle, ByVal 0&, ByVal 0&, &H1
                
                If mCurrIndex = -1 Then
                    SetEditText Hwnd, mText
                Else
                    SetEditText Hwnd, Item(mCurrIndex).Caption
                End If
                
                Exit Function
                
            Case vbKeyUp
            
                mCurrIndex = mCurrIndex - 1
                
                If mCurrIndex < -1 Then mCurrIndex = UBound(Item)
                
                RedrawWindow Handle, ByVal 0&, ByVal 0&, &H1
                
                If mCurrIndex = -1 Then
                    SetEditText Hwnd, mText
                Else
                    SetEditText Hwnd, Item(mCurrIndex).Caption
                End If
                
                Exit Function
                
            Case vbKeyEscape, vbKeyLeft, vbKeyRight
            
                If IsWindowVisible(Handle) Then
                    ShowWindow Handle, 0
                    SetEditText Hwnd, mText
                    ControlProc = 1
                    Exit Function
                End If
                
            Case vbKeyReturn
            
                If mCurrIndex = -1 Then SetEditText Hwnd, Item(mCurrIndex).Caption
                ShowWindow Handle, 0
        End Select
    End If
    
    ControlProc = CallWindowProc(ControlPrevProc, Hwnd, uMsg, wParam, lParam)
    
    Select Case uMsg
        
        Case WM_SETFOCUS
        
            mText = GetEditText(Hwnd)
            SetTimer Handle, 0, 50, AddressOf TimerProc
        
        Case WM_KILLFOCUS
        
            KillTimer Handle, 0
            ShowWindow Handle, 0
    
        Case WM_DESTROY
        
            Call StopSubClass
            
        Case WM_KEYUP
        
            Select Case wParam
                Case vbKeyEscape, vbKeyLeft, vbKeyRight, vbKeyDown, vbKeyUp, vbKeyReturn
                
                Case Else
                    Call TextChange
            End Select
            
    End Select
    Exit Function
ErrHandler:
    ShowWindow Handle, 0

End Function

Private Function LoWord(ByVal Numero As Long) As Long
    LoWord = Numero And &HFFFF&
End Function

Private Function HiWord(ByVal Numero As Long) As Long
    HiWord = Numero \ &H10000 And &HFFFF&
End Function

Private Function MakeDWord(ByVal LoWord As Integer, ByVal HiWord As Integer) As Long
    MakeDWord = (HiWord * &H10000) Or (LoWord And &HFFFF&)
End Function

Private Function SetEditText(Hwnd As Long, NewText As String)
    SetWindowText Hwnd, NewText
    SendMessage Hwnd, EM_SETSEL, Len(NewText), Len(NewText)
End Function

Private Function GetEditText(Hwnd As Long)
    Dim sBuff As String
    sBuff = String(100, Chr$(0))
    GetWindowText Hwnd, sBuff, 100
    GetEditText = Left$(sBuff, InStr(sBuff, Chr$(0)) - 1)
End Function

Function GetCode2(sUrl As String) As String

    Dim hOpen As Long, hFile As Long, sBuffer As String, Ret As Long
    
    sBuffer = Space(1000)

    hOpen = InternetOpen("VB-AutoComplete-TextBox", INTERNET_OPEN_TYPE_DIRECT, vbNullString, vbNullString, 0)

    hFile = InternetOpenUrl(hOpen, sUrl, vbNullString, ByVal 0&, INTERNET_FLAG_RELOAD, ByVal 0&)
    
    Do
        InternetReadFile hFile, sBuffer, 1000, Ret
        GetCode2 = GetCode2 & Left(sBuffer, Ret)
        If Ret = 0 Then Exit Do
    Loop
    
    InternetCloseHandle hFile
    InternetCloseHandle hOpen
    
End Function

Public Function GetCode(ByVal sUrl As String) As String
    Dim m_Inet As Object

    On Error GoTo Fail:
    
    'Set m_Inet = CreateObject("WinHttp.WinHttpRequest.5.1")
    Set m_Inet = CreateObject("Microsoft.XMLHTTP")
    'm_Inet.Option(0) = "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/535.11 (KHTML, like Gecko) Chrome/17.0.963.56 Safari/535.11"
    m_Inet.Open "GET", sUrl, True
    m_Inet.send
    
    'm_Inet.WaitForResponse
    Do While m_Inet.readystate <> 4
        DoEvents
    Loop
    
    If m_Inet.Status <> 200 Then GoTo Fail

    If LenB(m_Inet.ResponseText) = 0 Then GoTo Fail
    GetCode = m_Inet.ResponseText
   
    Exit Function
Fail:

End Function



Private Sub TextChange()
    On Error Resume Next
    Dim Rec         As RECT
    Dim sSearch     As String
    Dim sArray()    As String
    Dim sPart()     As String
    Dim UrlEncode   As String
    Dim i           As Long
    Dim j           As Long
    Dim sUrl        As String

    mText = GetEditText(hEdit)
    mCurrIndex = -1
    
    If mText = "" Then
        ShowWindow Handle, 0
        Exit Sub
    End If
    
    UrlEncode = Unicode2UTF8(mText)
    
    sUrl = Replace(mSearcherOfSuggestions, "{searchTerms}", UrlEncode)
    sUrl = Replace(sUrl, "{locale}", mLangName)
    
    sSearch = GetCode(sUrl)
    

    'sSearch = GetCode("http://ff.search.yahoo.com/gossip?output=fxjson&command=" & UrlEncode)
    'sSearch = GetCode("http://suggestqueries.google.com/complete/search?output=firefox&client=firefox&hl=" & mLangName & "&q=" & UrlEncode)
    'sSearch = GetCode("http://es.wikipedia.org/w/api.php?action=opensearch&search=" & UrlEncode)
    'sSearch = GetCode("http://suggestqueries.google.com/complete/search?output=firefox&client=firefox&&ds=yt&hl=" & mLangName & "&q=" & UrlEncode)
    
    sSearch = Replace(sSearch, Chr(34), vbNullString)
    sSearch = Replace(sSearch, "]", vbNullString)
    sSearch = Replace(sSearch, "[", vbNullString)
    'sSearch = UTF82Unicode(sSearch)
    
    
    If InStr(sSearch, ",") = 0 Then
        ShowWindow Handle, 0
        Exit Sub
    End If
    
    sArray = Split(sSearch, ",")


    If UBound(sArray) > 1 Then
        If sArray(1) = vbNullString Then
            ShowWindow Handle, 0
            Exit Sub
        End If
    End If
    
    mDC = GetDC(Handle)
    DeleteObject SelectObject(mDC, SendMessage(hEdit, WM_GETFONT, 0, ByVal 0&))
    GetWindowRect hEdit, Rec
    
    For i = 1 To UBound(sArray) - 1
        If sArray(i) <> vbNullString Then
            ReDim Preserve Item(j)
            Item(j).Caption = sArray(i)
            DrawText mDC, Item(j).Caption, Len(Item(j).Caption), Item(j).Rec, DT_CALCRECT
            SetRect Item(j).Rec, 0, Item(j).Rec.Bottom * j, Rec.Right - Rec.Left - 2, (Item(j).Rec.Bottom * j) + Item(j).Rec.Bottom
            j = j + 1
        End If
    Next
  
    If GetFocus() <> hEdit Then
        ShowWindow Handle, 0
        Exit Sub
    End If
  
    SetWindowPos Handle, HWND_TOPMOST, Rec.Left, Rec.Top + (Rec.Bottom - Rec.Top), Rec.Right - Rec.Left, Item(UBound(Item)).Rec.Bottom + 2, SWP_NOACTIVATE Or SWP_SHOWWINDOW 'Or SWP_NOMOVE Or SWP_NOSIZE
      
    RedrawWindow Handle, ByVal 0&, ByVal 0&, &H1

End Sub

Public Function UTF82Unicode(ByVal sUTF8 As String) As String
    Dim UTF8Size        As Long
    Dim BufferSize      As Long
    Dim BufferUNI       As String
    Dim LenUNI          As Long
    Dim bUTF8()         As Byte
    
    If LenB(sUTF8) = 0 Then Exit Function
    
    bUTF8 = StrConv(sUTF8, vbFromUnicode)
    UTF8Size = UBound(bUTF8) + 1
    
    BufferSize = UTF8Size * 2
    BufferUNI = String$(BufferSize, vbNullChar)
    
    LenUNI = MultiByteToWideChar(CP_UTF8, 0, bUTF8(0), UTF8Size, StrPtr(BufferUNI), BufferSize)
    
    If LenUNI Then UTF82Unicode = Left$(BufferUNI, LenUNI)

End Function


Public Function Unicode2UTF8(ByVal strUnicode As String) As String
    Dim LenUNI          As Long
    Dim BufferSize      As Long
    Dim LenUTF8         As Long
    Dim bUTF8()         As Byte
    
    LenUNI = Len(strUnicode)
    
    If LenUNI = 0 Then Exit Function
    
    BufferSize = LenUNI * 3 + 1
    ReDim bUTF8(BufferSize - 1)
    
    LenUTF8 = WideCharToMultiByte(CP_UTF8, 0, StrPtr(strUnicode), LenUNI, bUTF8(0), BufferSize, vbNullString, 0)
    
    If LenUTF8 Then
        ReDim Preserve bUTF8(LenUTF8 - 1)
        Unicode2UTF8 = StrConv(bUTF8, vbUnicode)
    End If

End Function

Public Function GetSystemLocaleInfo(ByVal lInfo As Long) As String
    Dim Buffer As String, Ret As String
    Buffer = String$(256, 0)

    Ret = GetLocaleInfo(LOCALE_USER_DEFAULT, lInfo, Buffer, Len(Buffer))

    If Ret > 0 Then
        GetSystemLocaleInfo = Left$(Buffer, Ret - 1)
    Else
        GetSystemLocaleInfo = ""
    End If
End Function

Private Function pvAlphaBlend(ByVal clrFirst As Long, ByVal clrSecond As Long, ByVal lAlpha As Long) As Long
    Dim clrFore         As UcsRgbQuad
    Dim clrBack         As UcsRgbQuad
    
    OleTranslateColor clrFirst, 0, VarPtr(clrFore)
    OleTranslateColor clrSecond, 0, VarPtr(clrBack)
    With clrFore
        .R = (.R * lAlpha + clrBack.R * (255 - lAlpha)) / 255
        .G = (.G * lAlpha + clrBack.G * (255 - lAlpha)) / 255
        .B = (.B * lAlpha + clrBack.B * (255 - lAlpha)) / 255
    End With
    CopyMemory pvAlphaBlend, clrFore, 4
End Function

