Attribute VB_Name = "MdlZoom"
Option Explicit

'----------------------------------------------------------------
'Autor:         Leandro Ascierto
'----------------------------------------------------------------

'=========User32 Api========
Private Declare Function EndPaint Lib "USER32" (ByVal Hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function BeginPaint Lib "USER32" (ByVal Hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal Hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32.dll" (ByVal hdc As Long, ByRef lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function RedrawWindow Lib "USER32" (ByVal Hwnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Private Declare Function SetTimer Lib "USER32" (ByVal Hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "USER32" (ByVal Hwnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Function ShowWindow Lib "user32.dll" (ByVal Hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function GetCursorPos Lib "USER32" (lpPoint As POINTAPI) As Long
Private Declare Function DrawText Lib "USER32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function DestroyWindow Lib "USER32" (ByVal Hwnd As Long) As Long
Private Declare Sub SetWindowPos Lib "USER32" (ByVal Hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function SendMessage Lib "USER32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, lParam As Any) As Long
Private Declare Function CreateWindowEx Lib "USER32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function SetWindowLong Lib "USER32" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "USER32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal Hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal Hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function PtInRect Lib "USER32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function PutFocus Lib "USER32" Alias "SetFocus" (ByVal Hwnd As Long) As Long
'=========GDI32 Api========
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function GetTextColor Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function SetBkColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetStockObject Lib "gdi32.dll" (ByVal nIndex As Long) As Long
'=========comctl32 Api========
Private Declare Function ImageList_GetIconSize Lib "comctl32.dll" (ByVal himl As Long, ByRef cx As Long, ByRef cy As Long) As Long
Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As Long, ByVal i As Long, ByVal hdcDst As Long, ByVal x As Long, ByVal y As Long, ByVal fStyle As Long) As Long

'=========Constantes========
Private Const HWND_TOPMOST              As Long = -1
Private Const HWND_NOTOPMOST            As Long = -2
Private Const SWP_NOSIZE                As Long = &H1
Private Const SWP_NOMOVE                As Long = &H2
Private Const SWP_NOACTIVATE            As Long = &H10
Private Const SWP_SHOWWINDOW            As Long = &H40
Private Const SWP_NOREDRAW              As Long = &H8

Private Const WS_BORDER                 As Long = &H800000
Private Const WS_CLIPSIBLINGS           As Long = &H4000000
Private Const WS_POPUP                  As Long = &H80000000
Private Const WS_DISABLED               As Long = &H8000000
Private Const WS_CHILD                  As Long = &H40000000

Private Const WS_EX_NOPARENTNOTIFY      As Long = &H4&
Private Const WS_EX_TOOLWINDOW          As Long = &H80&
Private Const WS_EX_TOPMOST             As Long = &H8&
Private Const WS_EX_WINDOWEDGE          As Long = &H100&

Private Const WM_PAINT                  As Long = &HF&
Private Const WM_MOUSEACTIVATE          As Long = &H21

Private Const DT_CALCRECT               As Long = &H400
Private Const DT_LEFT                   As Long = &H0
Private Const DT_VCENTER                As Long = &H4
Private Const DT_WORD_ELLIPSIS          As Long = &H40000
Private Const DT_SINGLELINE             As Long = &H20

Private Const GWL_WNDPROC               As Long = (-4)

Private Const DEFAULT_GUI_FONT          As Long = 17


'=========Estructuras========

Private Type RECT
    Left                    As Long
    Top                     As Long
    Right                   As Long
    Bottom                  As Long
End Type

Private Type POINTAPI
    x                       As Long
    y                       As Long
End Type

Private Type PAINTSTRUCT
    hdc                     As Long
    fErase                  As Long
    rcPaint                 As RECT
    fRestore                As Long
    fIncUpdate              As Long
    rgbReserved(1 To 32)    As Byte
End Type

Private Const LVM_FIRST         As Long = &H1000
Private Const LVM_GETITEMRECT   As Long = (LVM_FIRST + 14)

Private m_hImgList      As Long
Private m_ItemIcon      As Long
Private m_Name          As String
Private Handle          As Long
Private PrevProc        As Long
Private hImage          As Long
Private m_LV            As ucListView
Private m_ItemIndex     As Long
Private GdipToken       As Long
Private ArrImg()        As Byte


Public Sub ShowPreview(LV As ucListView, ByVal LI As Long, ByVal hImgList As Long, ctrlDownload As ucDownload)
    Dim RectLV As RECT
    Dim RectItem As RECT
    
    If hImage <> 0 Then GdipDisposeImage hImage: hImage = 0
    ctrlDownload.Download LV.SubItemText(LI, 1), "Zoom"
    
    Set m_LV = LV
    m_ItemIndex = LI
    
    m_hImgList = hImgList
    
    m_ItemIcon = LV.ItemIcon(LI)
    m_Name = LV.ItemText(LI)

    GetWindowRect LV.Hwnd, RectLV
    SendMessage LV.Hwnd, LVM_GETITEMRECT, LI, RectItem
    
    SetWindowPos Handle, HWND_TOPMOST, (RectLV.Left + RectItem.Left), (RectLV.Top + RectItem.Top), (RectItem.Right - RectItem.Left), (RectItem.Bottom - RectItem.Top), SWP_NOACTIVATE Or SWP_SHOWWINDOW 'Or SWP_NOREDRAW
    RedrawWindow Handle, ByVal 0&, ByVal 0&, &H1
    KillTimer Handle, 0
    SetTimer Handle, 0, 10, AddressOf TimerWindowZoomProc
    'Timer1.Interval = 50
End Sub

Public Sub SetArrImage(Arrbytes() As Byte)
    ArrImg = Arrbytes
    LoadImageFromStream ArrImg, hImage
    RedrawWindow Handle, ByVal 0&, ByVal 0&, &H1
End Sub

Public Sub Create(ByVal Hwnd As Long)
    Dim WinStyle As Long, WinStyleEx As Long
    WinStyle = WS_POPUP Or WS_BORDER Or WS_CLIPSIBLINGS Or WS_CHILD 'Or WS_DISABLED
    WinStyleEx = WS_EX_TOOLWINDOW Or WS_EX_TOPMOST Or WS_EX_WINDOWEDGE

    Handle = CreateWindowEx(WinStyleEx, "#32768", "Google Suggestion", WinStyle, 0, 0, 0, 0, Hwnd, ByVal 0&, App.hInstance, ByVal 0&)
 
    PrevProc = SetWindowLong(Handle, GWL_WNDPROC, AddressOf WindowZoomProc)

End Sub

Public Sub Destroy()
    SetWindowLong Handle, GWL_WNDPROC, PrevProc
    'KillTimer Handle, 0
    DestroyWindow Handle
End Sub

Sub TimerWindowZoomProc(ByVal Hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long)
    Dim Rec As RECT
    Dim PT As POINTAPI
    
    GetWindowRect Hwnd, Rec

    If ((Rec.Right - Rec.Left) < 251) And ((Rec.Bottom - Rec.Top) < 251) Then
        If Rec.Left <= 10 Then Rec.Left = 12: Rec.Right = Rec.Right + 24
        If Rec.Right >= (Screen.Width / Screen.TwipsPerPixelX) - 10 Then Rec.Left = Rec.Left - 20: Rec.Right = Rec.Right - 20
        SetWindowPos Hwnd, HWND_TOPMOST, Rec.Left - 10, Rec.Top - 10, Rec.Right - Rec.Left + 20, Rec.Bottom - Rec.Top + 20, SWP_NOACTIVATE Or SWP_SHOWWINDOW 'Or SWP_NOREDRAW
        RedrawWindow Handle, ByVal 0&, ByVal 0&, &H1
    End If
    
    GetCursorPos PT

    If PtInRect(Rec, PT.x, PT.y) = 0 Then
        ShowWindow Handle, 0
        KillTimer Handle, 0
    End If
 
End Sub

Public Sub ShowHide()
    ShowWindow Handle, 0
End Sub


Public Function WindowZoomProc(ByVal Hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim CapRec As RECT
    Dim PT As POINTAPI
    Dim PS As PAINTSTRUCT
    Dim hdc As Long
    Dim hBrush As Long
    

    If uMsg = WM_PAINT Then

        BeginPaint Hwnd, PS
        
        hBrush = CreateSolidBrush(vbWhite)
        FillRect PS.hdc, PS.rcPaint, hBrush
        DeleteObject hBrush
        DrawImage PS

        EndPaint Hwnd, PS
    ElseIf uMsg = WM_MOUSEACTIVATE Then
 
        m_LV.DeSelectAll
        m_LV.ItemSelected(m_ItemIndex) = True
        ShowWindow Handle, 0
        PutFocus m_LV.Hwnd
    End If
  
    WindowZoomProc = CallWindowProc(PrevProc, Hwnd, uMsg, wParam, lParam)

End Function

Public Sub ShowWindowZoom()
    Dim Rec As RECT
    
    Rec.Right = 300
    Rec.Bottom = 300
    
    SetWindowPos Handle, HWND_TOPMOST, Rec.Left, Rec.Top, (Rec.Right - Rec.Left), (Rec.Bottom - Rec.Top), SWP_NOACTIVATE Or SWP_SHOWWINDOW    'Or SWP_NOMOVE Or SWP_NOSIZE
      
    RedrawWindow Handle, ByVal 0&, ByVal 0&, &H1

End Sub

Private Sub DrawImage(PS As PAINTSTRUCT)
    
    Dim hGraphics As Long
    
    Dim lWidth As Long, lHeight As Long
    Dim PLeft As Long, PTop As Long
    Dim ReqWidth As Long, ReqHeight As Long
    Dim HScale As Double, VScale As Double
    Dim MyScale As Double
    Dim hBrush As Long
    Dim tRECT As RECT
    Dim sCaption As String
    
    lWidth = PS.rcPaint.Right - PS.rcPaint.Left
    lHeight = PS.rcPaint.Bottom - PS.rcPaint.Top


    If hImage <> 0 Then
        Dim ImgW As Single, ImgH As Single
        GdipGetImageDimension hImage, ImgW, ImgH
        If (ImgW = 0) Or (ImgH = 0) Then Exit Sub

        HScale = lWidth / ImgW
        VScale = lHeight / ImgH
        
        MyScale = IIf(VScale >= HScale, HScale, VScale)
          
        ReqWidth = (ImgW * MyScale)
        ReqHeight = (ImgH * MyScale)
          
        PLeft = ((lWidth - ReqWidth) / 2)
        PTop = ((lHeight - ReqHeight) / 2)

        
        GdipCreateFromHDC PS.hdc, hGraphics

        Call GdipDrawImageRectRectI(hGraphics, hImage, PLeft, PTop, ReqWidth, ReqHeight, 0&, 0&, ImgW, ImgH, &H2, 0&, 0&, 0&)
        
        GdipCreateSolidFill &HBF000000, hBrush
        GdipFillRectangleI hGraphics, hBrush, 0, lHeight - 24, lWidth, 24
        GdipDeleteBrush hBrush
        
        GdipDeleteGraphics hGraphics
        
        With tRECT
            .Left = 4
            .Top = lHeight - 24
            .Right = lWidth - 4
            .Bottom = lHeight
        End With
        
        sCaption = ImgW & " x " & ImgH & " - " & m_Name

        SetBkMode PS.hdc, 0
        SetTextColor PS.hdc, vbWhite
        SelectObject PS.hdc, GetStockObject(DEFAULT_GUI_FONT)
        DrawText PS.hdc, sCaption, Len(sCaption), tRECT, DT_LEFT Or DT_VCENTER Or DT_WORD_ELLIPSIS Or DT_SINGLELINE

    Else
        Dim lngImgW As Long, lngImgH As Long
        
        ImageList_GetIconSize m_hImgList, lngImgW, lngImgH
        If (lngImgW = 0) Or (lngImgH = 0) Then Exit Sub
        
        
        PLeft = ((lWidth - lngImgW) / 2)
        PTop = ((lHeight - lngImgH) / 2)

        ImageList_Draw m_hImgList, m_ItemIcon, PS.hdc, PLeft, PTop, &H1
        
    End If

End Sub
