VERSION 5.00
Begin VB.UserControl ucDownload 
   BackColor       =   &H00999999&
   ClientHeight    =   2220
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2715
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   2220
   ScaleWidth      =   2715
End
Attribute VB_Name = "ucDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' This component doesn't require any external calls/apis/references
' Obtains an url to a byte array using native VB6 calls
' Asyncronous - no need to wait for data to arrive
' Multiple downloads are accepted at the same time (different URL's, etc)
' If you like this code, please VOTE for it
' You may use this code freely in your projects, but whenever possible,
' include my name 'Filipe Lage' on the 'Help->About' or something ;)
' Cheers :)
'
' Filipe Lage
' fclage@ezlinkng.com
'

Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Public Event Progress(x As AsyncProperty, percent As Single, vKey As Variant)
Public Event Finished(x As AsyncProperty, vKey As Variant)

Public CurrentDownloads As New Collection
Private cKey As New Collection

Public Function Download(xurl As String, Optional vKey As Variant) As Boolean
    On Error Resume Next
    UserControl.AsyncRead xurl, vbAsyncTypeByteArray, xurl, vbAsyncReadResynchronize 'Or vbAsyncReadForceUpdate
    CurrentDownloads.Add xurl, xurl
    cKey.Add vKey, xurl
End Function

Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
    On Error Resume Next
    RaiseEvent Finished(AsyncProp, cKey(AsyncProp.PropertyName))
    
    CurrentDownloads.Remove AsyncProp.PropertyName
    cKey.Remove AsyncProp.PropertyName
    On Error GoTo 0
End Sub

Private Sub UserControl_AsyncReadProgress(AsyncProp As AsyncProperty)
    On Error Resume Next
    Dim p As Single
    If AsyncProp.BytesMax > 0 Then
        p = 100 * (AsyncProp.BytesRead / AsyncProp.BytesMax)
    Else
        p = 0
    End If
    
    RaiseEvent Progress(AsyncProp, p, cKey(AsyncProp.PropertyName))
End Sub

Private Sub UserControl_Resize()
    UserControl.Width = 960
    UserControl.Height = 960
End Sub

Public Sub CancelAllDownload()
On Error GoTo error_handler

    
    Do Until CurrentDownloads.Count = 0
        CancelDownload CurrentDownloads(1)
    Loop
    
    LockWindowUpdate ByVal 0
    Exit Sub
error_handler:

End Sub

Public Sub CancelDownload(xurl As String)
    On Error Resume Next
    UserControl.CancelAsyncRead CurrentDownloads(xurl)
    CurrentDownloads.Remove xurl
    On Error GoTo 0
    
End Sub


Private Sub UserControl_Terminate()
    Me.CancelAllDownload
End Sub
Private Function UIMode() As Boolean
    On Error Resume Next
    Err.Clear
    UIMode = (Err.Number <> 0)
    On Error GoTo 0
End Function

