VERSION 5.00
Begin VB.UserControl ImageWebSearch 
   ClientHeight    =   1605
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1440
   InvisibleAtRuntime=   -1  'True
   Picture         =   "ucImageWebSearch.ctx":0000
   ScaleHeight     =   1605
   ScaleWidth      =   1440
   ToolboxBitmap   =   "ucImageWebSearch.ctx":1B42
End
Attribute VB_Name = "ImageWebSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const WS_MINIMIZE As Long = &H20000000
Private Const WS_GROUP As Long = &H20000
Private Const GWL_STYLE As Long = -16

Public Enum SearchServer
    ssGoogle
    ssDevianart
End Enum

Private WithEvents FrmImgSearch As FrmSearchImgWeb
Attribute FrmImgSearch.VB_VarHelpID = -1
Private m_URL As String

Private m_Server As SearchServer
Private m_MultiSelect As Boolean
Private m_ShowPage As Boolean
Private m_EnabledZoom As Boolean
Private m_PanelPreviewVisible As Boolean
Private m_DefaultSearchWords As String
Private m_WordsSearchedByUser As String
Private m_bIsClose As Boolean
Private m_ThumbnailSize As Integer




Private Sub FrmImgSearch_DialogClose()
    m_bIsClose = True
End Sub

Private Sub UserControl_InitProperties()
    m_EnabledZoom = True
    m_ThumbnailSize = 160
End Sub

Private Sub UserControl_Resize()
    UserControl.Size 720, 720
End Sub

Private Sub FrmImgSearch_SearchResult(SearchWords As String, sFiles As String)
    m_WordsSearchedByUser = SearchWords
    m_URL = sFiles
End Sub

Public Property Get MultiSelect() As Boolean
    MultiSelect = m_MultiSelect
End Property
Public Property Let MultiSelect(ByVal Value As Boolean)
    m_MultiSelect = Value
    PropertyChanged "MultiSelect"
End Property

Public Property Get ServerSearch() As SearchServer
    ServerSearch = m_Server
End Property

Public Property Let ServerSearch(Value As SearchServer)
     m_Server = Value
     PropertyChanged "Server"
End Property

Public Property Get ShowPage() As Boolean
    ShowPage = m_ShowPage
End Property

Public Property Let ShowPage(Value As Boolean)
     m_ShowPage = Value
     PropertyChanged "ShowPage"
End Property

Public Property Get EnabledZoom() As Boolean
    EnabledZoom = m_EnabledZoom
End Property

Public Property Let EnabledZoom(Value As Boolean)
     m_EnabledZoom = Value
     PropertyChanged "EnabledZoom"
End Property

Public Property Get PanelPreviewVisible() As Boolean
    PanelPreviewVisible = m_PanelPreviewVisible
End Property

Public Property Let PanelPreviewVisible(Value As Boolean)
     m_PanelPreviewVisible = Value
     PropertyChanged "PanelPreviewVisible"
End Property

Public Property Get DefaultSearchWords() As String
    DefaultSearchWords = m_DefaultSearchWords
End Property

Public Property Let DefaultSearchWords(Value As String)
     m_DefaultSearchWords = Value
     PropertyChanged "DefaultSearchWords"
End Property

Public Property Get WordsSearchedByUser() As String
    WordsSearchedByUser = m_WordsSearchedByUser
End Property

Public Property Get ThumbnailSize() As Integer
    DefaultSearchWords = m_DefaultSearchWords
End Property

Public Property Let ThumbnailSize(Value As Integer)
     m_ThumbnailSize = Value
     If m_ThumbnailSize < 16 Then m_ThumbnailSize = 16
     If m_ThumbnailSize > 256 Then m_ThumbnailSize = 256
     PropertyChanged "ThumbnailSize"
End Property

Public Function ShowDialog(Optional ShowMode As FormShowConstants = vbModal, Optional Owner As Object = Nothing, Optional Width As Long = 16560, Optional Heigth As Long = 9615) As Boolean
    m_URL = vbNullString
    Set FrmImgSearch = New FrmSearchImgWeb
    With FrmImgSearch
        .EnabledZoom = m_EnabledZoom
        .MultiSelect = m_MultiSelect
        .PanelPreviewVisible = m_PanelPreviewVisible
        .ShowPage = m_ShowPage
        .Server = m_Server
        .DefaultSearchWords = m_DefaultSearchWords
        .ThumbnailSize = m_ThumbnailSize
        .Width = Width
        .Height = Heigth
    End With
    
    If ShowMode = vbModal Then
        SetWindowLong FrmImgSearch.Hwnd, GWL_STYLE, GetWindowLong(FrmImgSearch.Hwnd, GWL_STYLE) And Not (WS_MINIMIZE Or WS_GROUP)
    End If
    
    
    m_bIsClose = False
    
    FrmImgSearch.Show ShowMode, Owner
    
    If ShowMode = vbModeless Then
        Do While m_bIsClose = False
            DoEvents
        Loop
    End If
    
    Set FrmImgSearch = Nothing
    
    ShowDialog = Len(m_URL) > 0
    
End Function

Public Property Get URL() As String
    URL = m_URL
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        m_EnabledZoom = .ReadProperty("EnabledZoom", True)
        m_MultiSelect = .ReadProperty("MultiSelect", False)
        m_PanelPreviewVisible = .ReadProperty("PanelPreviewVisible", False)
        m_ShowPage = .ReadProperty("ShowPage", False)
        m_Server = .ReadProperty("Server", ssGoogle)
        m_DefaultSearchWords = .ReadProperty("DefaultSearchWords", vbNullString)
        m_ThumbnailSize = .ReadProperty("ThumbnailSize", 160)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "EnabledZoom", m_EnabledZoom, True
        .WriteProperty "MultiSelect", m_MultiSelect, False
        .WriteProperty "PanelPreviewVisible", m_PanelPreviewVisible, False
        .WriteProperty "ShowPage", m_ShowPage, False
        .WriteProperty "Server", m_Server, ssGoogle
        .WriteProperty "DefaultSearchWords", m_DefaultSearchWords, vbNullString
        .WriteProperty "ThumbnailSize", m_ThumbnailSize, 160
    End With
End Sub

